<template>
  <q-toolbar class="landing-toolbar">
    <q-btn
      round
      flat
      dense
      color="white"
      class="q-mx-md q-mx-md-2"
      @click="menu = !menu"
    >
      <q-avatar class="shadow-3">
        <img
          :src="
            searchEngines.find((se) => se.id === this.currentSearchEngine)
              .avatar
          "
      /></q-avatar>

      <img
        src="/statics/imgs/down-arrow.svg"
        height="5px"
        style="margin-top: 3px"
        class="col menu-indicator"
        :class="menu ? 'menu' : ''"
      />
      <q-menu :offset="[18, 10]" auto-close class="shadow-24">
        <q-list style="min-width: 100px">
          <q-item
            clickable
            v-for="se in searchEngines"
            :key="se.id"
            @click="setSearchEngine(se.id)"
          >
            <q-item-section avatar>
              <q-img :src="se.avatar"></q-img>
            </q-item-section>
            <q-item-section>{{ se.name }}</q-item-section>
          </q-item>
        </q-list>
      </q-menu>
    </q-btn>
    <q-input
      :placeholder="searchPlaceholder"
      ref="search"
      style="background-color: rgba(255, 255, 255, 0.75)"
      height="48px"
      color
      grow
      rounded
      outlined
      clearable
      clear-icon="img:imgs/bx-x-circle.svg"
      type="search"
      standout
      v-model="searchTerm"
      class="lh-searchbar"
      @keyup.enter="doSearch"
    ></q-input>
    <q-space></q-space>
  </q-toolbar>
</template>

<script>
import { mapActions, mapGetters } from "vuex";

export default {
  name: "SearchBar",
  data() {
    return {
      menu: false,
      currentSearchEngine: 0,
      searchTerm: "",
    };
  },
  computed: {
    ...mapGetters({
      search: "search",
      history: "userSearchHistory",
      searchEngines: "searchEngines",
      user: "user",
      initialSearchComplete: "initialSearchComplete",
      currentSearchTerm: "currentSearchTerm",
    }),
    // searchTerm: {
    //   set(searchString) {
    //     this.setSearchTerm(searchString);
    //   },
    //   get() {
    //     return this.currentSearchTerm;
    //   },
    // },
    searchPlaceholder() {
      return `Search ${
        this.searchEngines.find((se) => se.id === this.currentSearchEngine).name
      }`;
    },
  },
  watch: {
    searchTerm() {
      if (!this.searchTerm) {
        this.resetSearch();
      }
    },
  },
  methods: {
    ...mapActions({
      addSearch: "addSearch",
      clearSearch: "clearSearch",
      setSearchTerm: "setSearchTerm",
    }),
    setSearchEngine(param) {
      this.currentSearchEngine = param;
      if (this.searchTerm) {
        this.doSearch();
      }
    },
    doSearch() {
      let searchEngine = this.searchEngines.find(
        (se) => se.id === this.currentSearchEngine
      );
      let searchString = this.searchTerm;
      this.addSearch({
        timestamp: Date.now(),
        src: searchEngine,
        searchTerm: searchString,
      });
      this.$router.push("/search");
    },
    resetSearch() {
      this.clearSearch();
      this.$nextTick(function () {
        if (this.$router.page !== "app") {
          this.$router.push("/search");
        }
      });
    },
  },
};
</script>

<style>
.menu-indicator {
  margin-top: 3px;
  margin-right: 16px;
}

@media only screen and (max-width: 425px) {
  .q-toolbar {
    padding-right: 0px;
    padding-left: 0px;
  }
  .q-btn {
    margin-left: 8px;
    margin-right: 8px;
  }
  .lh-searchbar {
    margin-left: 0px;
    margin-right: 0px;
  }
  .no-right-margin {
    margin-right: 0px;
  }
  .menu-indicator {
    margin-right: 8px;
  }
}
</style>
